package counter

import (
  "log"
  "time"
  "encoding/json"
)

type statsTuple_t struct {
  Successful int `json:"good"`
  Failed int `json:"bad"`
}

type stats_t struct {
  Received statsTuple_t `json:"received"`
  Stored statsTuple_t `json:"stored"`
  Skipped statsTuple_t `json:"skipped"`
}

var stats stats_t

func S(id string) {
  switch id {
  case "Received": 
    stats.Received.Successful = stats.Received.Successful + 1
  case "Stored":
    stats.Stored.Successful += 1
  case "Skipped":
    stats.Skipped.Successful += 1
  default:
    log.Printf("Unknown stats id %s", id)
  }
}

func F(id string) {
  switch id {
  case "Received": 
    stats.Received.Failed += 1
  case "Stored":
    stats.Stored.Failed += 1
  case "Skipped":
    stats.Skipped.Failed += 1
  default:
    log.Printf("Unknown stats id %s", id)
  }
}

func InitCounter() {
  stats = stats_t {
    Received: statsTuple_t {Successful:0,Failed:0,},
    Stored: statsTuple_t {Successful:0,Failed:0,},
    Skipped: statsTuple_t {Successful:0,Failed:0,},
  }

  go func() { 
    for {
      sj, err := json.Marshal(stats)
      if err != nil {
        log.Printf("Unable to marshal stats object: %s", err)
      }
      log.Println(string(sj))
      time.Sleep(time.Second * 60)
    }
  }()
}

